/* $Id: token.h,v 1.6 2000/11/27 20:09:44 malekith Exp $ */

enum {
	sel_none = 0,
	sel_string,
	sel_int,
	sel_double,
	sel_ptr,
	sel_void,
	sel_op,
	sel_id,
	sel_syn,
	sel_kw,
};

enum {
	syn_file,		/* class, file */
	syn_class,		/* class_name, class_content */
	syn_class_name,		/* name(id), parent(id) */
	syn_class_content,	/* class_vars, class_procs */
	syn_class_vars,		/* var, class_vars */
	syn_class_procs,	/* proc, class_procs */
	
	syn_var,		/* type, var_names */
	syn_var_names,		/* one_var, var_names */
//	syn_one_var,		/* name(id), exp | 0 */
	
	syn_proc,		/* proc_sign, proc_args */
	syn_proc_sign,		/* type, name(id) */ 
	syn_proc_args,		/* texp, proc_args */
	syn_proc_arg,		/* type, name(id) */

	syn_syscall,		/* <=> syn_proc: proc_sign, syscall_args */
	syn_syscall_args,	/* proc_args, # */

	/* control */
	syn_alternative,	/* i1 else i2 */
	syn_while,		/* cond, ins */
	syn_do_while,		/* cond, ins */
	syn_if,			/* cond, alternative */
	syn_return,		/* exp|0, 0 */

	syn_call,		/* name(id), call_args */
	syn_call_args,		/* call_args, call_arg */
	syn_call_arg,		/* exp(), 0 */
	syn_call_arg_used,	/* already used arg */
	syn_pcall,		/* ptr(id), call */
	syn_pvar,		/* ptr(id), var(id) */
	syn_range,		/* class(id), var(id) */

	/* func: */
	syn_func,		/* func_info, func_body */
	syn_func_info,		/* type, func_name */
	syn_func_name,		/* class_name(id), function_name(id) */
	syn_func_body,		/* func_args, body(block) */
	syn_func_args,		/* func_arg, func_args */
	syn_func_arg,		/* type, name(id) */

	/* local variables */
	syn_lvars,		/* type(id), lvar_names */
	syn_lvar_names,		/* one_lvar, lvar_names */
	syn_one_lvar,		/* name(id), exp? */

	/* new/delete */
	syn_new,
	syn_delete,
};

struct token {
	struct token *left, *right;
	int sel;
	int line;
	char *file;
	union {
		char *s;
		int i; 
		real d;
		unsigned int ui;
	} u;
};

#define v_string	u.s
#define v_int		u.i
#define v_double	u.d
#define v_ptr		u.ui

struct token *new_token(struct token *left, struct token *right, int sel, ... );
void destroy_token(struct token *t);

